function yui = histequal(xui)

% function yui = histequal(xui)
%
% Perform histogram equalisation on xui.
%
% Nick Kingsbury, Cambridge University, 2006.

wh = waitbar(1/5,'Equalising histogram');

% Calculate intensity image and its 256-bin histogam.
L = 0.3*double(xui(:,:,1)) + 0.6*double(xui(:,:,2)) + 0.1*double(xui(:,:,3)) + 1;
histL = hist(L(:),[1:256]);
waitbar(2/5);

% Uncomment the next line to reduce the severity of the equalisation
% by adding a constant to all histogram bins.
% histL = histL + size(xui,1)*size(xui,2)/256; 

he = cumsum(255*histL/sum(histL));
% save histeq he histL

gain = he(round(L)) ./ L;
yui = uint8(zeros(size(xui)));
for k = 1:3,
    waitbar((k+2)/5);
    yui(:,:,k) = uint8(gain .* double(xui(:,:,k)) + 0.5);
end
close(wh) % Close wait bar
return
